metadata:
  name: boot-performance
  format: "Apertis Test Definition 1.0"
  image-types:
    minimal: [ armhf-internal, armhf, arm64, amd64 ]
    target:  [ armhf-internal, armhf, amd64 ]
    basesdk: [ amd64 ]
    sdk:     [ amd64 ]
  image-deployment:
    - APT
    - OSTree
  type: performance
  exec-type: automated
  priority: high
  maintainer: "Apertis Project"
  description: "Test boot performance. This test checks boot performance using
                systemd-analyze statistics."

  expected:
    - "The output should be similar to this:"
    - |
        >Running test systemd-analyze time ...
        Startup finished in 6.856s (firmware) + 436ms (loader) + 1.311s (kernel) + 2.160s (userspace) = 10.763s
        (firmware)	6.856s
        (loader)	436ms
        (kernel)	1.311s
        (userspace)	2.160s
        Running test systemd-analyze blame ...
        (boot.mount)	857ms
        (iptables.service)	402ms
        (dev-sda3.device)	380ms
        (ribchester-core.service)	361ms
        (ondemand.service)	266ms
        (connman-wait-online.service)	262ms
        (ssh.service)	150ms
        (polkit.service)	130ms
        (systemd-journald.service)	124ms
        (systemd-logind.service)	123ms
        (apertis-create-homedir.service)	117ms
        (vboxvideo.service)	115ms
        (connman.service)	105ms
        (systemd-udev-trigger.service)	102ms
        (var-rw.service)	99ms
        (dev-mqueue.mount)	98ms
        (systemd-remount-fs.service)	98ms
        (tmp.mount)	96ms
        (wpa_supplicant.service)	95ms
        (dev-hugepages.mount)	95ms
        (sys-kernel-debug.mount)	94ms
        (apparmor.service)	81ms
        (systemd-udevd.service)	64ms
        (systemd-journal-flush.service)	62ms
        (systemd-modules-load.service)	58ms
        (systemd-tmpfiles-setup.service)	52ms
        (systemd-tmpfiles-setup-dev.service)	51ms
        (user@1000.service)	46ms
        (kmod-static-nodes.service)	46ms
        (systemd-random-seed.service)	44ms
        (systemd-timesyncd.service)	43ms
        (systemd-user-sessions.service)	38ms
        (run-ribchester-general.mount)	34ms
        (boot-efi.mount)	31ms
        (etc-rw.service)	25ms
        (systemd-update-utmp.service)	22ms
        (run-user.mount)	21ms
        (apt-daily-upgrade.service)	18ms
        (systemd-sysctl.service)	18ms
        (home.mount)	17ms
        (media.mount)	14ms
        (canterbury-init.service)	11ms
        (var-Applications.mount)	10ms
        (root.mount)	7ms
        (etc.mount)	7ms
        (apt-daily.service)	6ms
        (systemd-update-utmp-runlevel.service)	5ms
        (systemd-tmpfiles-clean.service)	5ms
        (Applications.mount)	4ms
    - "If any test failed, they will be listed instead of the success message:"
    - |
        >>>> The following tests FAILED:
        [list of tests]

install:
  git-repos:
    - url: https://gitlab.apertis.org/tests/boot-performance-automated.git
      branch: 'apertis/v2021dev2'

run:
  steps:
    - "# Enter test directory:"
    - cd boot-performance-automated
    - "common/run-test-in-systemd --timeout=900 --no-lava --name=boot-performance-automated sh -c './run-test.sh | sed \"/^(.*/ s/\\$/ :pass/\"'"

parse:
  pattern: ^\((?P<test_case_id>\w[\w\d\.\@\-]+)\)\W+(?P<measurement>\d*\.?\d+)m?s\s\:(?P<result>pass)
